<template>
  <v-dialog v-model="dialog" persistent max-width="50%">
    <v-card>
      <v-card-title>
        <span v-text="title" />
      </v-card-title>
      <v-card-text>
        <v-container>
          <v-row>
            <v-col cols="3" v-if="isEdit">
              <v-text-field label="NMS ID*" v-model="nms.id" required readonly />
            </v-col>
            <v-col cols="3">
              <v-text-field label="NMS Nama*" v-model="nms.nama" :disabled="statusProgress" required />
            </v-col>
            <v-col cols="3">
              <v-select
                  :disabled="statusProgress"
                  v-model="nms.vendor"
                  :items="vendors"
                  label="Pilih Vendor"
              >
              </v-select>
            </v-col>
            <v-col cols="3">
              <v-text-field label="IP Server*" v-model="nms.ip_server" :disabled="statusProgress" required/>
            </v-col>
          </v-row>
          <v-row>
            <v-col cols="3">
              <v-text-field label="Port TL1*" type="number" v-model="nms.port_tl1" :disabled="statusProgress" required/>
            </v-col>
            <v-col cols="3">
              <v-select
                  :disabled="statusProgress"
                  v-model="nms.protocol"
                  :items="protocols"
                  label="Pilih Protocol"
              >
              </v-select>
            </v-col>
            <v-col cols="3">
              <v-text-field label="Username" v-model="username" :disabled="statusProgress" required/>
            </v-col>
            <v-col cols="3">
              <v-text-field label="Password" v-model="password" :disabled="statusProgress" required/>
            </v-col>
          </v-row>
        </v-container>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue darken-1" text @click="doSaveOrUpdate" :disabled="statusProgress">Simpan</v-btn>
        <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
        <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
      </v-card-actions>
    </v-card>
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-dialog>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import service from "../service/NmsService";

export default {
  name: "NmsForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      nms: {
        id: null,
        nama: null,
        vendor: null,
        ip_server: null,
        port_tl1: null,
        protocol: null,
        username: null,
        password: null,
      },
      username: null,
      password: null,
      vendors: [],
      protocols: [],
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    doAdd(title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.doReset()
      this.retrieveVendorAndProtocol()
    },
    doEdit(id, title, isEdit) {
      this.title = title
      this.dialog = true
      this.isEdit = isEdit
      this.retrieveNms(id)
    },
    doReset() {
      this.nms.id = null
      this.nms.nama = null
      this.nms.vendor = null
      this.nms.ip_server = null
      this.nms.port_tl1 = null
      this.nms.protocol = null
      this.nms.username = null
      this.nms.password = null
      this.username = null
      this.password = null
    },
    async doSaveOrUpdate() {
      if (!this.validation()) {
        return
      }
      let data = this.nms
      data.username = this.username
      data.password = this.password

      this.statusProgress = true
      if (!this.isEdit) {
        await this.doSave(data)
      } else {
        await this.doUpdate(data.id, data)
      }
      this.statusProgress = false
    },
    doSave(data) {
      service.store(data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    doUpdate(id, data) {
      service.update(id, data)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              await this.$parent.doRefresh()
              this.doReset()
            }
            this.dialog = false
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg('ERROR EXCEPTION')
          })
    },
    async retrieveNms(id) {
      this.statusProgress = true
      await service.getId(id)
          .then(async res => {
            if (res.data.status === 'SUCCESS') {
              await this.retrieveVendorAndProtocol()
              this.nms = res.data.data
            } else {
              this.$refs.dlgMsg.doOpenMsg(res.data.message)
            }
          })
      this.statusProgress = false
    },
    async retrieveVendorAndProtocol() {
      this.statusProgress = true
      await service.getVendor().then(res => {
        let {status, data} = res.data
        if (status === 'SUCCESS') {
          this.vendors = data
        }
      })
      await service.getProtocol().then(res => {
        let {status, data} = res.data
        if (status === 'SUCCESS') {
          this.protocols = data
        }
      })
      this.statusProgress = false
    },
    validation() {
      if (this.nms.nama == null || this.nms.nama === '') {
        this.$refs.dlgMsg.doOpenMsg("Nama Harus Diisi")
        return false
      } else if (this.nms.vendor == null) {
        this.$refs.dlgMsg.doOpenMsg("Vendor Harus Dipilih")
        return false
      } else if (this.nms.ip_server == null || this.nms.ip_server === '') {
        this.$refs.dlgMsg.doOpenMsg("IP Server Harus Diisi")
        return false
      } else if (this.nms.port_tl1 == null || this.nms.port_tl1 === '') {
        this.$refs.dlgMsg.doOpenMsg("Port Harus Diisi")
        return false
      } else if (this.nms.protocol == null) {
        this.$refs.dlgMsg.doOpenMsg("Protocol Harus Dipilih")
        return false
      }
      return true
    }
  },
}
</script>

<style scoped>

</style>